<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers\Admin;
use Illuminate\Http\Request;
use App\Http\Helper\Helper;
use App\Validators\AuthValidator;
use Illuminate\Support\Facades\Hash;
use App\Managers\User\UserManager;
use Illuminate\Support\Facades\Mail;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\Auth;
use App\Managers\SessionToken\SessionTokenManager;
use Illuminate\Support\Facades\Cookie;

class AuthApiController extends Controller
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->authValidator = new AuthValidator();
        $this->userManager = new UserManager();
        $this->sessionTokenManager = new SessionTokenManager();
    }
    
    public function login(Request $request)
    {
        if(!$request->all() || !$request->exists('data'))
        {
            return response()->json(['No Input Found'], 400);
            exit;
        }
        $data = $request->get('data');
        $data = $this->helper->changeSerialzeArrayValues($data);
        $validation = $this->authValidator->login($data);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        if (Auth::attempt(['email' => $data['email'], 'password' => $data['password'] . 'abcdef45674', 'type' => 'admin', 'active' => 1])) {
            $user = $this->userManager->where('email', $data['email'])->first();
            Session::put('admin', $user->UUID);
            Session::put('type', $user->type);
            Session::put('email', $user->email);
            
            $tokenData['UUID'] = $this->helper->addUUID();;
            $tokenData['user_id'] = $user->UUID;
            $tokenData['token'] = hash('sha256', rand(1000000,9999999) . date('dmyhis'));
            $tokenData['created_at'] = $tokenData['updated_at'] = date("Y-m-d H:i:s");
            
            $sessionTokenRes = $this->sessionTokenManager->where('token', $tokenData['token'])->first();
            if($sessionTokenRes)
            {
                return response()->json(['Something Went Wrong. Please Login Again'], 401);
                exit;
            }
            
            $res = $this->sessionTokenManager->insert($tokenData);
            if(!$res)
            {
                return response()->json(['Something Went Wrong. Please Login Again'], 401);
                exit;
            }
            
            //$response = new \Illuminate\Http\Response();
            Cookie::queue(Cookie::make('auth_code_a', $tokenData['token'], 100000));
            
            return response()->json(['Login Successful'], 200);
            exit;
        }
        return response()->json(['Email and Password Not Match'], 500);
    }
}