<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers\Admin;
use App\Http\Helper\Helper;
use App\Validators\AuthValidator;
use App\Managers\User\UserManager;
use App\Http\Controllers\Controller;
use App\Managers\Decision\DecisionManager;
use App\Managers\Proposal\ProposalManager;
use App\Managers\TacticSuggestions\TacticSuggestionsManager;
use App\Managers\Schedule\ScheduleManager;

class DashboardController extends Controller
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->authValidator = new AuthValidator();
        $this->userManager = new UserManager();
        $this->decision = new DecisionManager();
        $this->proposal = new ProposalManager();
        $this->tacticSuggestions = new TacticSuggestionsManager();
        $this->schedule = new ScheduleManager();
    }
    
    public function index()
    {
        $res['user_count'] = $this->userManager->where('deleted_at', NULL)->count();
        $res['decision'] = $this->decision->where('deleted_at', NULL)->count();
        $res['proposal'] = $this->proposal->where('deleted_at', NULL)->count();
        $res['tacticSuggestions'] = $this->tacticSuggestions->where('deleted_at', NULL)->count();
        $res['users'] = $this->userManager->where('deleted_at', NULL)->orderBy('created_at', 'DESC')->skip(0)->take(8)->get();
        $res['schedule'] = $this->schedule->with('opposite_team_det')->where('deleted_at', NULL)->orderBy('created_at', 'DESC')->skip(0)->take(5)->get();
        
        return view('/admin/index')->with('res', $res);
    }
}